Scap3 should break up remote deploy tasks
Closed, ResolvedPublic

Description

For the code executed on the target machines, we need to divide things up into distinct phases.

Probably something like:

  • Prepare (git fetch, build config?)
  • Activate (swap symlinks, restart services)
  • Test (run service checks)
thcipriani updated the task description. (Show Details)
thcipriani raised the priority of this task from to Needs Triage.
thcipriani added a project: Scap.
thcipriani added subscribers: thcipriani, mmodell, demon, dduvall.
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptAug 21 2015, 5:23 PM
dduvall triaged this task as High priority.Aug 21 2015, 5:30 PM
dduvall assigned this task to demon.
dduvall set Security to None.
dduvall moved this task from Needs triage to Services MVP on the Scap board.
demon removed demon as the assignee of this task.

I'm not entirely sure what this task is all about

mmodell updated the task description. (Show Details)Sep 11 2015, 5:48 PM

Per our sprint meeting discussion last Friday, the main reasoning behind breaking up deployment into distinct stages is to be able to independently control the batch sizes, ultimately leading to a more efficient overall process. Specifically, Git fetching/cloning and possibly other preparatory/build tasks could be executed in larger batches concurrently, while the final promotion (symlink swaps, service restart, etc.) are still done is a more serial fashion (rolling restart).

dduvall claimed this task.Sep 15 2015, 10:49 PM
dduvall renamed this task from Scap3 service sync should break up remote deploy tasks to Scap3 should break up remote deploy tasks.
dduvall moved this task from Services improvements to Services MVP on the Scap board.

Change 238631 had a related patch set uploaded (by Dduvall):
Execute distinct stages of deployment separately

https://gerrit.wikimedia.org/r/238631

Another benefit to this design is that it simplifies any general before/after hook implementation that we may want to support in the future.

Change 238631 merged by jenkins-bot:
Execute distinct stages of deployment separately

https://gerrit.wikimedia.org/r/238631

dduvall moved this task from Services MVP to Done on the Scap board.Sep 17 2015, 12:20 AM
thcipriani closed this task as Resolved.Sep 17 2015, 12:22 AM

Patch merged, good framework in place for any further stage breakouts. Closing.